/**********************************\
Lagometer - Created by ADT_CLONE

The lagometer is a proc that you can include in your game to calculate lag.

FindLag(display=null,who=src,isprecise=1)

Display - This is how it will be displayed. Null=It will only return the statment, "screen"=It will display the meter on the screen, "text"=It will tell who the amount of lag
Who - Who is executing the proc
Isprecise - If this is true(1) the value will be the precise amount lag. If it is false(0) it will be a rounded amount of lag
*/


proc
	FindLag(display=null,mob/who=src,preciseo=1)
		if(isnull(who))return
		var/time1
		var/time2
		who<<"<B>Calculating Lag</B>"
		var/obj/meter
		if(display=="screen")
			meter=new /obj/Lagometer()
			who.client.screen+=meter
			meter.screen_loc="1,1"
		time1=world.timeofday
		sleep(50)
		time2=world.timeofday
		var/precise=(time2-time1-50)/10
		var/time=round(max((time2-time1-50)/10,0.25),1)
		if(display=="screen")
			if(time>8)
				meter.icon_state="broken"
				flick("brokena",meter)
			else
				meter.icon_state="[time]"
			spawn(50)
				del(meter)
		if(display=="text")
			if(preciseo)
				usr<<"<B>Lagometer Reads: </B>[precise] Lag"
			else
				usr<<"<B>Lagometer Reads: </B>[time] Lag"
		if(preciseo)
			return precise
		else
			return time
obj
	Lagometer
		icon='Lagometer.dmi'
		icon_state="move"
		layer=MOB_LAYER+1000